/* VS-RC003 SDK Sample program (c)Vstone */

#include	<stdio.h>
#include	<stdlib.h>
#include	<windows.h>
#include    <tchar.h>
#include	"VSRC003_SDK.h"

BOOL GetFilename(char *buff);

void main()
{
	int loopnumber=0;
	char fpath[MAX_PATH];
	int i=0;

	printf("VS-RC003 SDK sample program\n");
	printf("Written by Masahiro 04/12/2011\n\n");

	printf("In this sample, it will allow you to load a motion file and play the motion onto your robot.\n");

	memset(fpath,0,sizeof(fpath));

	//First you have to specify the initial motion which contains several poses of your startup poses.
	//	if your motion start form standing up position, 
	//	the init moition will contain 3 to 5 standup poses.
	printf("Initializing Robot.  Please specify your init motion.\n\n");
	if(!GetFilename(fpath)) return ;

	if(VSRC003_LoadMotion(fpath)){ printf("Failed to load init motion."); return;}
	if(VSRC003_PlayMotion(loopnumber)){ printf("Failed to play motion.\n\n"); return;}
	else printf("Starting to play init motion.\n\n");
	printf("init motion file F%s\n\n",fpath);

	//waits for finish playing init motion
	do{
		Sleep(16);
	}while(VSRC003_GetStatus()==ERR_PLAYINGMOTION);
	printf("Finished playing init motion.\n\n");

	//Select motion to play.
	printf("Please select a motion file to play.\n\n");
	if(!GetFilename(fpath)) return ;

	//Load Motion File
	printf("Selected motion fileF%s\n\n",fpath);
	printf("Now Loading the motion file .........\n");
	if(VSRC003_LoadMotion(fpath)){ printf("Failed to load motion file\n"); return;}
	else printf("Finished loading motion file.\n");
	
	//Turning on Servo motors
	printf("Turning on the servo motors\n");
	if(VSRC003_ServoPower(1)){ printf("Failed to turning on the servo motors\n\n"); return;}
	else printf("Power applied to the servo motors.\n\n");


	//Play motion
	printf("Please selec number of loop count -1 ` 32767.  Please select -1 for infinit loop\n");
	//For the use of loop count, you must have a loop block in your motion file
	scanf("%d",&loopnumber);

	if(loopnumber==ENDLESS) printf("Infinit loop is selected\n");
	else printf("Loop count: %d\n",loopnumber);
	//if(VSRC003_PlayMotion(loopnumber)){ printf("Failed to play motion\n\n"); return;}
	if(VSRC003_PlayMotion(-1)){ printf("Failed to play motion\n\n"); return;}
	else printf("Start Playing motion\n\n");


	//Now Playing the motion
	printf("Please press ESC to stop playing motion\n\n");
	do{
		Sleep(16);
		if(GetKeyState(VK_ESCAPE) & 0x80){
			printf("ESC is recognized.  Stop playing motion.\n");
			if(VSRC003_CancelMotion()){ printf("Failed to stop motion\n"); return;}
			else printf("Finished Playiong motion\n");
			break;
		}
		//printf("Status: %d\n", VSRC003_GetStatus());

	}while(VSRC003_GetStatus()==ERR_PLAYINGMOTION);

	printf("Waiting for the process on CPU board ends\n");
	Sleep(1000);

	//Turn off servo motors
	printf("Turning off servo motors\n");
	if(VSRC003_ServoPower(0)){ printf("Failed to turn off servo motor\n\n"); return;}
	else printf("Turned off servo motors\n\n");


	printf("Finished.\n");
	while(1);
	return;
}

//function to get file name
BOOL GetFilename(char *buff)
{
	OPENFILENAME fname;
	static char fpath[MAX_PATH];
	char filename[64],inifilter[]="txt\0*.txt\0";

	memset(fpath,0,sizeof(fpath));
	memset(filename,0,sizeof(filename));

	memset(&fname, 0, sizeof(OPENFILENAME)) ;
	fname.lStructSize = sizeof(OPENFILENAME) ;
	fname.hwndOwner = NULL ;	
	fname.lpstrFilter = inifilter ;
	fname.nFilterIndex = 1 ;
	fname.lpstrFile = fpath ;
	fname.nMaxFile = sizeof(fpath) ;
	fname.lpstrFileTitle = filename ;
	fname.nMaxFileTitle = (sizeof(filename))-1 ;
	fname.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY ;
	fname.lpstrDefExt = "txt" ;
	fname.lpstrTitle = "Motion load VSRC003 SDK sample" ;

	if(!GetOpenFileName(&fname)) return FALSE;

	strcpy(buff,fpath);
	return TRUE;
}
